import json
from main import default_vm_node, default_storage


# Data transfer class to combine all necessary VM information
class VmProxMoxDTO:
    def __init__(self, vm_name, vm_cores, vm_memory, vm_disk_size, vm_expire_days,
                 vm_iso_file):
        self.node = default_vm_node
        if not isinstance(vm_name, str):
            raise ValueError("Name must be a string.")
        self.vm_name = vm_name
        if not isinstance(vm_cores, int):
            raise ValueError("Cores must be a int.")
        self.vm_cores = vm_cores
        if not isinstance(vm_memory, int):
            raise ValueError("Memory (Mb) must be a int.")
        self.vm_memory = vm_memory
        self.vm_storage = default_storage
        if not isinstance(vm_disk_size, int):
            raise ValueError("Disk size (Gb) must be a int.")
        self.vm_disk_size = str(vm_disk_size) + 'G'
        if not isinstance(vm_expire_days, int):
            raise ValueError("Expire_days must be a int.")
        self.vm_expire_days = vm_expire_days
        self.vm_iso_file = vm_iso_file


    def to_json(self):
        vm_data = {
            'node': self.node,
            'vm_name': self.vm_name,
            'vm_cores': self.vm_cores,
            'vm_memory': self.vm_memory,
            'vm_storage': self.vm_storage,
            'vm_disk_size': self.vm_disk_size,
            'vm_expire_days': self.vm_expire_days,
            'vm_iso_file': self.vm_iso_file
        }
        return json.dumps(vm_data)
