# Generated by Django 4.2.1 on 2023-06-16 09:29

from django.conf import settings
import django.contrib.auth.models
import django.contrib.auth.validators
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'}, help_text='Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=150, unique=True, validators=[django.contrib.auth.validators.UnicodeUsernameValidator()], verbose_name='username')),
                ('user_id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('email', models.EmailField(max_length=255)),
                ('first_name', models.CharField(max_length=128, null=True)),
                ('last_name', models.CharField(max_length=128, null=True)),
                ('is_active', models.BooleanField(default=False)),
                ('is_staff', models.BooleanField(default=False)),
                ('maxAmountOfVms', models.IntegerField(null=True)),
                ('is_superuser', models.BooleanField(default=False)),
                ('password', models.CharField(max_length=255)),
                ('vlanTag', models.IntegerField(null=True)),
                ('last_login', models.DateTimeField(auto_now=True)),
                ('date_joined', models.DateTimeField(auto_now_add=True)),
                ('email_confirmed', models.BooleanField(default=False)),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'abstract': False,
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='DefaultSettings',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('lease_time_months', models.IntegerField()),
                ('memory_mbs', models.IntegerField()),
                ('storage_gbs', models.IntegerField()),
                ('cores', models.IntegerField()),
                ('notification_email', models.EmailField(max_length=254)),
                ('amount_of_vms', models.IntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='Iso',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('is_visible', models.BooleanField()),
                ('os_name', models.CharField(max_length=255)),
                ('volid', models.CharField(max_length=320)),
            ],
        ),
        migrations.CreateModel(
            name='RequestType',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('name', models.CharField(max_length=20, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='Vm',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('name', models.CharField(max_length=64)),
                ('end_date', models.DateTimeField()),
                ('memory_mbs', models.IntegerField()),
                ('storage_gbs', models.IntegerField()),
                ('cores', models.IntegerField()),
                ('iso_id', models.ForeignKey(max_length=11, null=True, on_delete=django.db.models.deletion.SET_NULL, to='main.iso')),
                ('user_id', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Request',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('message', models.CharField(max_length=256)),
                ('is_approved', models.BooleanField(default=None, null=True)),
                ('date_time', models.DateTimeField(auto_now=True)),
                ('request_type_id', models.ForeignKey(max_length=11, null=True, on_delete=django.db.models.deletion.SET_NULL, to='main.requesttype')),
                ('user_id', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('vm_id', models.ForeignKey(max_length=11, null=True, on_delete=django.db.models.deletion.CASCADE, to='main.vm')),
            ],
        ),
    ]
