import time
from main.Utils import remove_vm_by_id
from main.db_functions import get_list_vms_to_expire, get_list_vms_expired, get_list_of_unconfirmed_users, \
    remove_user_db
from main.mail_utils import send_vm_expire_letter
from background_task import background


@background(schedule=24*60*60)
def send_notification_expiring_vm():
    queryset = get_list_vms_to_expire()
    for vm in queryset:
        user_email = str(vm.user_id.email)
        send_vm_expire_letter(user_email, vm.name)
        time.sleep(10)


@background(schedule=24*60*60)
def remove_expired_vms():
    vms_expired = get_list_vms_expired()
    for vm in vms_expired:
        remove_vm_by_id(vm.id)


@background(schedule=24*60*60)
def remove_unconfirmed_users():
    users_list = get_list_of_unconfirmed_users()
    for user in users_list:
        remove_user_db(user.username)


remove_unconfirmed_users(repeat=24*60*60)
remove_expired_vms(repeat=24*60*60)
send_notification_expiring_vm(repeat=24*60*60)





